# coding: utf-8

# flake8: noqa

"""
    IONOS Cloud - Managed Stackable Data Platform API

    Managed Stackable Data Platform by IONOS Cloud provides a preconfigured Kubernetes cluster with pre-installed and managed Stackable operators. After the provision of these Stackable operators, the customer can interact with them directly and build his desired application on top of the Stackable Platform.  Managed Stackable Data Platform by IONOS Cloud can be configured through the IONOS Cloud API in addition or as an alternative to the \"Data Center Designer\" (DCD).  ## Getting Started  To get your DataPlatformCluster up and running, the following steps needs to be performed.  ### IONOS Cloud Account  The first step is the creation of a IONOS Cloud account if not already existing.  To register a **new account** visit [cloud.ionos.com](https://cloud.ionos.com/compute/signup).  ### Virtual Datacenter (VDC)  The Managed Data Stack needs a virtual datacenter (VDC) hosting the cluster. This could either be a VDC that already exists, especially if you want to connect the managed DataPlatform to other services already running within your VDC. Otherwise, if you want to place the Managed Data Stack in a new VDC or you have not yet created a VDC, you need to do so.  A new VDC can be created via the IONOS Cloud API, the IONOS-CLI or the DCD Web interface. For more information, see the [official documentation](https://docs.ionos.com/cloud/getting-started/tutorials/data-center-basics)  ### Get a authentication token  To interact with this API a user specific authentication token is needed. This token can be generated using the IONOS-CLI the following way:  ``` ionosctl token generate ```  For more information [see](https://docs.ionos.com/cli-ionosctl/subcommands/authentication/token-generate)  ### Create a new DataPlatformCluster  Before using Managed Stackable Data Platform, a new DataPlatformCluster must be created.  To create a cluster, use the [Create DataPlatformCluster](paths./clusters.post) API endpoint.  The provisioning of the cluster might take some time. To check the current provisioning status, you can query the cluster by calling the [Get Endpoint](#/DataPlatformCluster/getCluster) with the cluster ID that was presented to you in the response of the create cluster call.  ### Add a DataPlatformNodePool  To deploy and run a Stackable service, the cluster must have enough computational resources. The node pool that is provisioned along with the cluster is reserved for the Stackable operators. You may create further node pools with resources tailored to your use-case.  To create a new node pool use the [Create DataPlatformNodepool](paths./clusters/{clusterId}/nodepools.post) endpoint.  ### Receive Kubeconfig  Once the DataPlatformCluster is created, the kubeconfig can be accessed by the API. The kubeconfig allows the interaction with the provided cluster as with any regular Kubernetes cluster.  The kubeconfig can be downloaded with the [Get Kubeconfig](paths./clusters/{clusterId}/kubeconfig.get) endpoint using the cluster ID of the created DataPlatformCluster.  ### Create Stackable Service  To create the desired application, the Stackable service needs to be provided, using the received kubeconfig and [deploy a Stackable service](https://docs.stackable.tech/home/getting_started.html#_deploying_stackable_services)  ## Authorization  All endpoints are secured, so only an authenticated user can access them. As Authentication mechanism the default IONOS Cloud authentication mechanism is used. A detailed description can be found [here](https://api.ionos.com/docs/authentication/).  ### Basic-Auth  The basic auth scheme uses the IONOS Cloud user credentials in form of a Basic Authentication Header accordingly to [RFC7617](https://datatracker.ietf.org/doc/html/rfc7617)  ### API-Key as Bearer Token  The Bearer auth token used at the API-Gateway is a user related token created with the IONOS-CLI. (See the [documentation](https://docs.ionos.com/cli-ionosctl/subcommands/authentication/token-generate) for details) For every request to be authenticated, the token is passed as 'Authorization Bearer' header along with the request.  ### Permissions and access roles  Currently, an admin can see and manipulate all resources in a contract. A normal authenticated user can only see and manipulate resources he created.   ## Components  The Managed Stackable Data Platform by IONOS Cloud consists of two components. The concept of a DataPlatformClusters and the backing DataPlatformNodePools the cluster is build on.  ### DataPlatformCluster  A DataPlatformCluster is the virtual instance of the customer services and operations running the managed Services like Stackable operators. A DataPlatformCluster is a Kubernetes Cluster in the VDC of the customer. Therefore, it's possible to integrate the cluster with other resources as vLANs e.G. to shape the datacenter in the customer's need and integrate the cluster within the topology the customer wants to build.  In addition to the Kubernetes cluster a small node pool is provided which is exclusively used to run the Stackable operators.  ### DataPlatformNodePool  A DataPlatformNodePool represents the physical machines a DataPlatformCluster is build on top. All nodes within a node pool are identical in setup. The nodes of a pool are provisioned into virtual data centers at a location of your choice and you can freely specify the properties of all the nodes at once before creation.  Nodes in node pools provisioned by the Managed Stackable Data Platform Cloud API are readonly in the customer's VDC and can only be modified or deleted via the API.  ### References   # noqa: E501

    The version of the OpenAPI document: 0.0.7
    Generated by: https://openapi-generator.tech
"""


from __future__ import absolute_import

__version__ = "1.0.0"

# import apis into sdk package
from ionoscloud_dataplatform.api.data_platform_cluster_api import DataPlatformClusterApi
from ionoscloud_dataplatform.api.data_platform_meta_data_api import DataPlatformMetaDataApi
from ionoscloud_dataplatform.api.data_platform_node_pool_api import DataPlatformNodePoolApi

# import ApiClient
from ionoscloud_dataplatform.api_client import ApiClient
from ionoscloud_dataplatform.configuration import Configuration
from ionoscloud_dataplatform.exceptions import OpenApiException
from ionoscloud_dataplatform.exceptions import ApiTypeError
from ionoscloud_dataplatform.exceptions import ApiValueError
from ionoscloud_dataplatform.exceptions import ApiKeyError
from ionoscloud_dataplatform.exceptions import ApiAttributeError
from ionoscloud_dataplatform.exceptions import ApiException
# import models into sdk package
from ionoscloud_dataplatform.models.availability_zone import AvailabilityZone
from ionoscloud_dataplatform.models.cluster import Cluster
from ionoscloud_dataplatform.models.cluster_list_response_data import ClusterListResponseData
from ionoscloud_dataplatform.models.cluster_response_data import ClusterResponseData
from ionoscloud_dataplatform.models.create_cluster_properties import CreateClusterProperties
from ionoscloud_dataplatform.models.create_cluster_request import CreateClusterRequest
from ionoscloud_dataplatform.models.create_node_pool_properties import CreateNodePoolProperties
from ionoscloud_dataplatform.models.create_node_pool_request import CreateNodePoolRequest
from ionoscloud_dataplatform.models.error_message import ErrorMessage
from ionoscloud_dataplatform.models.error_response import ErrorResponse
from ionoscloud_dataplatform.models.maintenance_window import MaintenanceWindow
from ionoscloud_dataplatform.models.metadata import Metadata
from ionoscloud_dataplatform.models.node_pool import NodePool
from ionoscloud_dataplatform.models.node_pool_list_response_data import NodePoolListResponseData
from ionoscloud_dataplatform.models.node_pool_response_data import NodePoolResponseData
from ionoscloud_dataplatform.models.patch_cluster_properties import PatchClusterProperties
from ionoscloud_dataplatform.models.patch_cluster_request import PatchClusterRequest
from ionoscloud_dataplatform.models.patch_node_pool_properties import PatchNodePoolProperties
from ionoscloud_dataplatform.models.patch_node_pool_request import PatchNodePoolRequest
from ionoscloud_dataplatform.models.storage_type import StorageType

